
// Cursor movement control

#include	<curses.h>
#include	<string.h>


int 	top = 0, left = 0, right = 0, bottom = 0;
int 	width = 50, height = 20;
int	input;
int 	beg = 0,end = 70;
int 	count = 0,count1 = 0;

struct node
	{
		char array[77];
		int index;
		struct node *up;
		struct node *down;
	};
		   	
	typedef struct node NODE;	
	

// variables

int 	y, x, no_lines;
int 	wy=-1,wx=-1;
int 	i=1,prev_x;
WINDOW 	*edit_sub_win, *menu_bar_win, *status_bar_win, *edit_main_win;
NODE 	*first,*last;
NODE 	*cur;
NODE 	*temp1;


// Function prototypes

void	move_right();
void	move_left();
void	move_up();
void	move_down();
void	page_up();
void	page_down ();

void 	left_margin();
void	top_margin();
void	right_margin();
void	bottom_margin();

void	char_del();
void	word_del();
void	word_ins(char);
void	enter();
void	ins_ln();
void	del_ln();

void	about_us();
void	how2edit();
int 	get_margin(char*);
void	error_input(char*, int ,int ,int ,int);

NODE 	*create_node();

// Function Definitions

void	page_up()
{
	
	for (i=0;i< 15;i++)
		move_up();
}

void	page_down()
{
	
	for (i=0;i< 15;i++)
		move_down();
}

	
void	word_del()
{
	char ch;
	int count = 0;
	getyx (edit_sub_win,wy,wx);
	int f = 0;
	while (ch != ' ')
	{
		ch = cur->array[wx];
		char_del();
		f = 1;
	}

}

void	word_ins(char ch)
{
	char temp;
	int i;

	getyx (edit_sub_win, wy,wx);
//	ch = wgetch (edit_sub_win);
	if (cur->index+1 == width)
	{	
		temp = cur->array[cur->index-1];
                wmove (edit_sub_win,wy+1,wx);
		winsertln (edit_sub_win);
		waddch (edit_sub_win, temp);
		wmove (edit_sub_win,wy-2,wx);		
	}
	else
	{

		for (i = cur->index;i > wx+1; i--)
			cur->array[i+1] = cur->array[i];
		cur->array[i+1] = cur->array[i];	
		cur->array[i] = ch;
		i = 0;
		cur->index++;
		cur->array[cur->index] = '\0';
		wmove (edit_sub_win,wy,left-1);
		wclrtoeol(edit_sub_win);
		for (i=left;i < cur->index && cur->array[i] != '\0'; i++)
			mvwaddch (edit_sub_win, wy,left+i,cur->array[i]);

		wmove (edit_sub_win,wy,cur->index);		
		wclrtoeol(edit_sub_win);
	}
        wmove (edit_sub_win,wy,wx);
        wrefresh (edit_sub_win);
}
void	move_down()
{
	height = 17- (top+bottom);
	getyx (edit_sub_win,wy,wx);
	scrollok (edit_sub_win,TRUE);
	if (cur->down == NULL)
	{
		beep();
		
	}
	else
	{
		if (wy == 17-bottom)
		{
			cur = cur->down;
			y++;
			wmove (edit_sub_win,wy - height, left);
			wclrtoeol (edit_sub_win);
			wmove (edit_sub_win,17-bottom,wx);
			wscrl(edit_sub_win,1);
			for (i=left;i < cur->index; i++)
			mvwaddch (edit_sub_win, wy,i,cur->array[i]);

			
		}
		else
		{
			wy++;
			y++;
			cur = cur->down;
		}
		wmove (edit_sub_win,wy,left);
	}
	if (x > cur->index) wx =x= cur->index;
}
void	move_up()
{
	getyx (edit_sub_win,wy,wx);
	scrollok (edit_sub_win,TRUE);
	if (cur->up == NULL)
	{
		beep();
		
	}
	else
	{
		if  (wy == top)
		{
			cur = cur->up;
			y--;
			wmove (edit_sub_win,wy + height, left);
			wclrtoeol (edit_sub_win);
			wmove (edit_sub_win,top,wx);
			wscrl (edit_sub_win,-1);
			for (i=left;i < cur->index; i++)
			mvwaddch (edit_sub_win, wy,i,cur->array[i]);
		}
		else
		{
			wy--;
			y--;
			cur = cur->up;
		}
		wmove (edit_sub_win,wy,left);
	}
	if (x > cur->index) wx = x = cur->index;
}

void 	char_del()
{
	wmove(edit_sub_win,y,x);
	prev_x = x;
	for (i=x;i <=cur->index;i++)
		cur->array[i] = cur->array[i+1];
	cur->index--;
	wdelch(edit_sub_win);
	wmove (edit_sub_win,y,cur->index);
	wclrtoeol(edit_sub_win);
	//wrefresh(edit_sub_win);
        x = prev_x;
}
void	move_left()
{
	if(x<=left) { beep();x=left;}
	else
	x--;
	wmove (edit_sub_win, y, x);
}

void	move_right()
{
	if(x >= cur->index) {beep(); x = cur->index ;}
	else
	x++;
	wmove (edit_sub_win, y, x);	
}

void 	enter()
{	
        NODE *temp;
	char t[80];
	int i,wy,wx,k=0;
	getyx (edit_sub_win,wy,wx);
//	gotline(y);
        temp=create_node();
	if (wx < cur->index)
	{

	wmove (edit_sub_win,wy+1,x);
	winsertln(edit_sub_win);
	for ( i=wx + 1; cur->array[i] != '\0';i++)
		{
		t[k++] = cur->array[i];
		
		}
		
	wmove (edit_sub_win,wy,wx);
	wclrtoeol(edit_sub_win);
	t[k] = '\0';
	cur->index = x+1;
	cur->array[wx+1] = '\0';
	strcpy (temp->array,t);
	temp->index = k;
	mvwprintw (edit_sub_win,wy+1,left,"%s",t);
	wrefresh (edit_sub_win);
	}
	else if (wx == left)
	{
		winsertln (edit_sub_win);
		wmove (edit_sub_win,y,x);
		temp->index = 0;
		temp->array[0] = '\0';
	}

	
	temp->up = cur;
	temp->down = cur->down;
	cur->down = temp;
	cur  = cur->down;
	
	no_lines++;
 	y++;
	x = left;
}

NODE* 	create_node(void)
{	NODE *temp;
	temp=(NODE*) new NODE;
	temp->index=left;
	temp->array[0] = '\0';
	temp->down=NULL;
	temp->up = NULL;
	return temp;
}
void	left_margin()
{
	int qy;
	left = get_margin("Left Margin :");
	if (left < 0) left = 0;
	if (left > 10)
	{
		error_input("Exceeds max limit",3,25,3,48);
		left = 10;
	}
	
	wmove (edit_sub_win, top,left);
	
//	wprintw (edit_sub_win,"%d",left);
}

void	top_margin()
{
	int qy;
	top = get_margin("Top Margin :");
	if (top < 0) top = 0;
	if (top > 10)
	{
		error_input("Exceeds max limit",3,25,3,48);
		top = 10;
	}
	wmove (edit_sub_win, top, left);
//	wprintw (edit_sub_win,"%d",top);
	
}

void	right_margin()
{
	int qy;
	right = get_margin("Right Margin :");
	if (right < 0) right = 0;
	if (right > 10)
	{
		error_input("Exceeds max limit",3,25,3,48);
		right = 10;
	}
	
//	wprintw (edit_sub_win,"%d",right);
	
}
void	bottom_margin()
{
	int qy;
	bottom = get_margin("Bottom Margin :");
	if (bottom < 0) bottom = 0;
	if (bottom > 10)
	{
		error_input("Exceeds max limit",3,25,3,48);
		bottom = 10;
	}
	
//	wprintw (edit_sub_win,"%d",bottom);
}

void	del_ln()
{
	int ty;
	NODE *temp,*temp1;

	if (cur->down == NULL)
	{
		beep();
		return;
	}
	else  if ((cur->down != NULL) && (cur->up == NULL))
	{
		wdeleteln(edit_sub_win);
		cur->down = cur->down->down;
	}
	else
	{
		wdeleteln(edit_sub_win);
		temp = cur->up ;
		temp->down = cur->down;
		cur->down->up = temp;
		cur = cur->down;
	}
}

void	ins_ln()
{
	NODE *temp;
	temp = create_node();
	if ((cur->up == NULL) && (cur->down != NULL))
	{
		temp->down = cur;
		//cur = cur->down;
		first = temp;
		winsertln(edit_sub_win);
	}
	else if ((cur->down == NULL)&& (cur->up != NULL))
	{
	     	cur->down = temp;
	     	temp->up = cur;
	     	winsertln(edit_sub_win);
	}
	else  if ((cur->down != NULL) && (cur->up != NULL))	
	{
		temp->down = cur->down;
		temp->up = cur->up;
		cur->up->down = temp;
		cur->down->up = temp;
		//cur = cur->down;
		winsertln(edit_sub_win);
	}
	else
		beep();
	return ;
 }

void    how2edit()
{
	WINDOW *win;
	win = newwin (13,34,4,23);
	init_pair(5, COLOR_RED, COLOR_WHITE);
	wcolor_set( win, 5 , NULL);
	wbkgd (win, COLOR_PAIR(5));
	box (win,ACS_VLINE, ACS_HLINE);
	mvwprintw (win, 1,7,"%s", "How to edit ?");
	mvwprintw (win, 3, 4,"%s", "F1		Help");
	mvwprintw (win, 4, 4,"%s", "F2		File Save");
	mvwprintw (win, 5, 4,"%s", "F3		File Open");
	mvwprintw (win, 6, 4,"%s", "F4		File Delete");	
	mvwprintw (win, 7, 4,"%s", "F5		Foreground color");	
	mvwprintw (win, 8, 4,"%s", "F6		Background color");		
	mvwprintw (win, 10, 4,"%s", "Ctrl+x	Exit");
	mvwprintw (win, 11, 4,"%s", "F10		Exit");

	
	wrefresh (win);
	
	wgetch (edit_sub_win);
	delwin (win);
	
}

void 	about_us()
{	
	WINDOW *win;
	win = newwin (12,40,5,20);
	init_pair(5, COLOR_RED, COLOR_WHITE);
	wcolor_set( win, 5 , NULL);
	wbkgd (win, COLOR_PAIR(5));
	box (win,ACS_VLINE, ACS_HLINE);
	mvwprintw (win, 1,10,"%s", "EDITMAGIC - ver 1.0.1");
	mvwprintw (win, 3, 4,"%s", "(c) 2000 - 2001 TOPGUN INC");
	mvwprintw (win, 5, 5,"%s", "Authors(***)");
	mvwprintw (win, 6,11,"%s", "VIJAY & VIVEK");
	mvwprintw (win, 7,11,"%s", "<maverick_topgun@sify.com>");
	mvwprintw (win, 9, 4,"%s", "Editmagic is a very small and light");
	mvwprintw (win, 10, 8,"%s", "weight screen editor.");
	
	wrefresh (win);
	
	wgetch (edit_sub_win);
	delwin (win);
}

int	get_margin(char *text)
{
	WINDOW *win;
	int input;
	win = newwin (3,25,3,48);
	init_pair(5, COLOR_RED, COLOR_WHITE);
	wcolor_set( win, 5 , NULL);
	wbkgd (win, COLOR_PAIR(5));
	box (win,ACS_VLINE, ACS_HLINE);
	wrefresh(win);
	echo();
	mvwprintw (win,1,2,"%s", text);
	wscanw (win,"%d",&input);
	delwin (win);
	noecho();
	cbreak();
	return input;
}

void  error_input(char *text,int no_rows,int no_cols,int beg_y,int beg_x)
{	
	WINDOW *win ;
	char ch;
	int no_chars = 0,i=0;
	win = newwin (no_rows,no_cols, beg_y, beg_x);
	init_pair (5,COLOR_RED, COLOR_WHITE);
	wcolor_set (win,5,NULL);
	wbkgd (win,COLOR_PAIR (5));
	box (win,ACS_VLINE,ACS_HLINE);
	mvwprintw (win, 1, 3, "%s", text);
	noecho();
	cbreak();
	wrefresh(win);
	wgetch(edit_sub_win);
	delwin (win);
}	



