
#include	"cursor.h"
#include	<ctype.h>
#include	<curses.h>
#include	<unistd.h>

// Variables
int COLOR_F=7,COLOR_B=4,B_ROW=21,R_COL=78,T_ROW=1,L_COL=1,flag=0,C_PAIR=20,TAB=8,start=0,FULLROW=1,FULLCOL=1; 
int row=1,col=1; 
char 	filename[11];
int file_saved = 1;
// Function Prototypes
void    change_tab(WINDOW*);
void 	new_file();
void 	file_open(int);
void	file_save(int);
void	file_delete();
void	file_exit();
void	drawbox(char *,int,int,int,int,int);
	
// Function Definitions

void 	new_file()
{
	y = top;
	x = left;
	if (!file_saved) file_save(1);
	
	wclear (edit_sub_win);	
	wclear (status_bar_win);
	strcpy (filename,"Newfile");
	first = last = cur = create_node();
	wmove (edit_sub_win, y, x);

}


void 	file_open (int flag)
{
	y = top;
	x = left;
	no_lines = top;	
	
	if (!file_saved) file_save(1);
	FILE *fp;
	char ch;
	if ( flag == 1)
	drawbox (" Input Filename to open ",4,30,5,16,1);
	
	wclear (edit_sub_win);

	fp = fopen (filename,"r");
	cur = last = first = create_node();
	if (fp == 0)
	{
		//error_input (" Invalid File  ",5,30,5,16);	
		strcpy (filename,"Noname");
		return ;
	}

	else
	
	while (!feof(fp))
	{	
		ch = fgetc (fp);
		if (ch == '\n')
		{
			last=create_node();
			last->up = cur;
			cur->down = last;
			cur->index = x;
			cur  = cur->down;
			no_lines++;
		 	y++;
			x = left;
		}
			
		else
		{	
	 		cur->array[x] =  ch;
	 		mvwaddch(edit_sub_win,y,x,cur->array[x]);
	 		x++;	 		
	 		if ( x >= width)
	 		x = left;
	 	}
	 }
	 y = top,x = left;
	 cur = first;
	 wmove (edit_sub_win , y, x);
	 wclear (status_bar_win);
	 fclose (fp);

}
void	file_save(int flag)
{	
	int j,k;
	cur = first;
	char ch;
	FILE *fp ;
	if (flag == 1)
	drawbox ("Input File to Save ",4,30,5,16,1);
	else  if (flag == 2)
	{
		drawbox ("Deleting contents of file .... ",5,40,5,16,0);
		wgetch (edit_sub_win);
		sleep (1);
		
	}
	NODE *temp;
//	wgetch (edit_sub_win);

	fp = fopen(filename,"w");
	
	for (temp = first;temp != NULL;temp = temp->down)
	{	
		for (k = 0; k <= temp->index; k++)
		{
			ch = temp->array[k];
			if (ch == '\0')
			fputc('\n',fp);
			else
			{
				if (flag == 1)
				fputc(ch,fp);
			}
		}
	 }
  	rewind(fp);
  	cur = first;
  	wmove (edit_sub_win,0,0);
  	
  	fputc('\n',fp);
	file_saved = 1;
	fclose (fp);
}
void	file_exit()
{
	if (!file_saved)
	file_save(1);
	endwin();
	exit (EXIT_SUCCESS);
	
	
}
void	file_delete()
{
	char temp[11],fname[11],temp1[41];
	strcpy (temp,filename);
	drawbox ("Input File to Delete ",4,30,5,16,1);
	strcpy (fname,"rm ");
	strcat (fname, filename);
	strcpy (temp1,"File \"");
	strcat (temp1,filename);
	strcat (temp1,"\" deleted ...");
	strcpy (filename,temp);
	error_input (temp1,4,30,5,16);
	system (fname);
 }


void drawbox (char *text,int no_rows,int no_cols,int beg_y,int beg_x,int flag)
{	
	WINDOW *win ;
	char ch;
	int no_chars = 0,i=0;
        char fname[11];
        strcpy (fname,filename);
	win = newwin (no_rows,no_cols, beg_y, beg_x);
	init_pair (5,COLOR_RED, COLOR_WHITE);
	wcolor_set (win,5,NULL);
	wbkgd (win,COLOR_PAIR (5));
	box (win,ACS_VLINE,ACS_HLINE);
	mvwprintw (win, 1, 3, "%s", text);
	
	echo();
	if (flag == 1)
	{       wmove (win, 2,3);
		wscanw (win,"%s",filename);
	}
	else
	{       noecho();
//		wgetch (edit_sub_win);
		strcpy (filename,fname);
	}
	
	noecho();
	cbreak();
	delwin (win);
}

void change_tab(WINDOW *edit_sub_win) 
{ 
        int i,j,ch; 
        WINDOW *w1 = newwin(5,43,10,12); 
        WINDOW *w2; 
        w2=newwin(5,43,11,13); 
        init_pair (4, COLOR_BLACK, COLOR_BLACK); 
        wattrset(w2,COLOR_PAIR(4)); 
        wbkgd(w2,' ' | COLOR_PAIR(4));wrefresh(w2); 
        init_pair (2, COLOR_BLACK, COLOR_WHITE); 
        wattrset(w1,COLOR_PAIR(2)); 
        wbkgd(w1,' ' | COLOR_PAIR(2)); 
        box(w1,ACS_VLINE,ACS_HLINE); 
        mvwaddstr(w1,2,1,"Enter the number of spaces for tab: "); 
        wmove(w1,2,18); 
        wrefresh(w1); 
        echo(); 
        mvwscanw(w1,2,37,"%d",&i); 
        werase(w1); 
        if(i<=0) 
        { 
                box(w1,ACS_VLINE,ACS_HLINE); 
                mvwaddstr(w1,2,6,"Error entering tab spaces"); 
                wrefresh(w1); 
                wgetch(w1); 
                werase(w1); 
                wrefresh(w1); 
                delwin(w1); 
                
                wrefresh(edit_sub_win); 
                return ; 
        }wrefresh(w1); 
        while(1){
                noecho(); 
                ch=wgetch(edit_sub_win); 
                 wrefresh(edit_sub_win);
        switch(ch)
        {
         case 9		: 
			for (j=0;j<TAB;j++) 
			{ 
				waddch (edit_sub_win,' '); 
				x++; 
				cur->array[x] = ' ';
                            
                        }break; 
                       
                        wrefresh(edit_sub_win);}
        wrefresh(edit_sub_win); 
       TAB=i; 
}}
